package org.jeecg.modules.stm.bcs.handle.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.bcs.handle.entity.BcsHandleOrg;
import org.jeecg.modules.stm.bcs.handle.service.IBcsHandleOrgService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 应急组织
 * @Author: jeecg-boot
 * @Date:   2025-09-25
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/bcs.handle/bcsHandleOrg")
@Slf4j
public class BcsHandleOrgController extends JeecgController<BcsHandleOrg, IBcsHandleOrgService> {
	@Autowired
	private IBcsHandleOrgService bcsHandleOrgService;
	
	/**
	 * 分页列表查询
	 *
	 * @param bcsHandleOrg
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "应急组织-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<BcsHandleOrg>> queryPageList(BcsHandleOrg bcsHandleOrg,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BcsHandleOrg> queryWrapper = QueryGenerator.initQueryWrapper(bcsHandleOrg, req.getParameterMap());
		Page<BcsHandleOrg> page = new Page<BcsHandleOrg>(pageNo, pageSize);
		IPage<BcsHandleOrg> pageList = bcsHandleOrgService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param bcsHandleOrg
	 * @return
	 */
	@AutoLog(value = "应急组织-添加")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_org:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BcsHandleOrg bcsHandleOrg) {
		bcsHandleOrgService.save(bcsHandleOrg);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param bcsHandleOrg
	 * @return
	 */
	@AutoLog(value = "应急组织-编辑")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_org:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BcsHandleOrg bcsHandleOrg) {
		bcsHandleOrgService.updateById(bcsHandleOrg);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "应急组织-通过id删除")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_org:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		bcsHandleOrgService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "应急组织-批量删除")
	  
	@RequiresPermissions("bcs.handle:bcs_handle_org:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.bcsHandleOrgService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "应急组织-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<BcsHandleOrg> queryById(@RequestParam(name="id",required=true) String id) {
		BcsHandleOrg bcsHandleOrg = bcsHandleOrgService.getById(id);
		if(bcsHandleOrg==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(bcsHandleOrg);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param bcsHandleOrg
    */
	//@RequiresPermissions("bcs.handle:bcs_handle_org:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BcsHandleOrg bcsHandleOrg) {
        return super.exportXls(request, bcsHandleOrg, BcsHandleOrg.class, "应急组织");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
	//@RequiresPermissions("bcs.handle:bcs_handle_org:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BcsHandleOrg.class);
    }

}
